From 181ec089e72b9a207c06dce24507dc34b000b7a7 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 08 2015 02:16:02 +0000
Subject: [PATCH 98/1001] First pass at check hinting.


---

diff --git a/hubs/consumer.py b/hubs/consumer.py
index 08d1eca..da79a59 100644
--- a/hubs/consumer.py
+++ b/hubs/consumer.py
@@ -1,7 +1,8 @@
 # The fedora hubs backend daemon
 
+import collections
+import threading
 import time
-import random
 
 import fedmsg.consumers
 
@@ -27,11 +28,38 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         if not self.uri:
             raise ValueError('hubs.sqlalchemy.uri must be present')
 
+        self.hint_cache_lock = threading.Lock()
+        session = self.make_session()
+        with self.hint_cache_lock:
+            self.rebuild_hubs_hint_caches(session)
+        session.commit()  # transaction is committed here
+        session.close()
+
         log.info("CacheInvalidatorExtraordinaire initialized")
 
     def make_session(self):
         return hubs.models.init(self.uri)
 
+    def rebuild_hubs_hint_caches(self, session):
+        self.checks_by_topic = collections.defaultdict(list)
+        self.checks_by_category = collections.defaultdict(list)
+
+        widgets = session.query(hubs.models.Widget).all()
+        log.info("Comparing message against %i widgets" % len(widgets))
+        for widget in widgets:
+            check = widget.module.should_invalidate
+            if not hasattr(check, 'hints'):
+                raise AttributeError("%r must declare hints" % widget.module)
+            for topic in check.hints['topics']:
+                self.checks_by_topic[topic].append((check, widget,))
+            for category in check.hints['categories']:
+                self.checks_by_category[category].append((check, widget,))
+
+
+    @property
+    def cache_initialized(self):
+        return self.checks_by_topic and self.checks_by_category
+
     def consume(self, raw_msg):
         session = self.make_session()
         try:
@@ -43,6 +71,7 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
 
     def work(self, session, raw_msg):
         topic, msg = raw_msg['topic'], raw_msg['body']
+        category = topic.split('.')[3]
 
         for suffix in self.junk_suffixes:
             if topic.endswith(suffix):
@@ -53,20 +82,26 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         log.info("CacheInvalidatorExtraordinaire received %s %s",
                   msg['msg_id'], msg['topic'])
 
+        if category == 'hubs' or not self.cache_initialized:
+            # Someone has modified an object in the hubs database, so let's
+            # rebuild our cache of our own database.
+            with self.hint_cache_lock:
+                self.rebuild_hubs_hint_caches(session)
+
         # Begin our real work.
         # Find which widgets should have their caches nuked and make it so.
 
-        # First, make a thread-local copy of the widgets.
-        widgets = list(session.query(hubs.models.Widget).all())
-        log.info("Comparing message against %i widgets" % len(widgets))
-
-        # Shuffle it so that not all threads step through the list in the same
-        # order.  This should cut down on competition for the dogpile lock.
-        random.shuffle(widgets)
-
-        # And do the real work of comparing every widget against the message.
-        for widget in widgets:
-            if widget.module.should_invalidate(msg, session, widget):
+        # Start this by finding a subset of widget checks that might match this
+        # message. Look them up based on the hints they declare.
+        checks = \
+            set(self.checks_by_topic[topic]) + \
+            set(self.checks_by_category[category])
+        log.info("Found %i checks to try for this message" % len(checks))
+
+        # Then, with that hopefully smaller list of checks, try them all and
+        # see if any tell us that we should nuke various data caches.
+        for check, widget in checks:
+            if check(msg, session, widget):
                 log.info("Invalidating cache for %r" % widget)
                 # Invalidate the cache...
                 invalidate_cache(widget.module, **widget.config)
diff --git a/hubs/hinting.py b/hubs/hinting.py
new file mode 100644
index 0000000..64a58ed
--- /dev/null
+++ b/hubs/hinting.py
@@ -0,0 +1,28 @@
+import collections
+import decorator
+
+import fedmsg.config
+
+import logging
+log = logging.getLogger('hubs.hinting')
+
+
+def hint(topics=None, categories=None):
+    topics = topics or []
+    categories = categories or []
+
+    @decorator.decorator
+    def wrapper(fn, *args, **kwargs):
+        return fn(*args, **kwargs)
+
+    def wrapper_wrapper(fn):
+        wrapped = wrapper(fn)
+        wrapped.hints = dict(topics=topics, categories=categories)
+        return wrapped
+
+    return wrapper_wrapper
+
+
+def prefixed(topic, prefix='org.fedoraproject'):
+    config = fedmsg.config.load_config()  # This is memoized for us.
+    return '.'.join([prefix, config['environment'], topic])
diff --git a/hubs/widgets/dummy.py b/hubs/widgets/dummy.py
index d0c9e57..28f48fb 100644
--- a/hubs/widgets/dummy.py
+++ b/hubs/widgets/dummy.py
@@ -1,3 +1,4 @@
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
 
@@ -16,6 +17,7 @@ def data(session, widget, text):
     return dict(text=text)
 
 
+@hint(topics=[_('hubs.widget.update')])
 def should_invalidate(message, session, widget):
     if not message['topic'].endswith('hubs.widget.update'):
         return False
diff --git a/hubs/widgets/rules.py b/hubs/widgets/rules.py
index 3e0fb4d..ae36938 100644
--- a/hubs/widgets/rules.py
+++ b/hubs/widgets/rules.py
@@ -2,6 +2,7 @@ from collections import OrderedDict as ordereddict
 
 import jinja2
 
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument, avatar
 from hubs import validators
@@ -45,6 +46,7 @@ def data(session, widget, link):
     return dict(owners=owners, link=link)
 
 
+@hint(topics=[_('hubs.widget.update'), _('hubs.hub.update')])
 def should_invalidate(message, session, widget):
     if message['topic'].endswith('hubs.widget.update'):
         if message['msg']['widget']['id'] == widget.id:
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index 03090a4..1826c62 100644
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -1,3 +1,4 @@
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 
 import jinja2
@@ -21,7 +22,7 @@ def data(session, widget):
     )
 
 
-# TODO -- add topic-based hinting here.  Solved.
+@hint(topics=_('hubs.hub.update'))
 def should_invalidate(message, session, widget):
     if message['topic'].endswith('hubs.hub.update'):
         if message['msg']['hub']['name'] == widget.hub.name:

